<template>
  <div class="m-40 flex justify-center">
    <div
      v-if="
        loginProcessState === 'waiting to start' ||
        loginProcessState === 'login is refused'
      " 
    >
      <div class="w-full max-w-sm">
        <div class="md:flex md:items-center mb-6">
          <div class="md:w-1/3">
            <label
              class="ada-form-label"
              for="the-page-login--email"
            >
              {{ $t('login.email') }}
            </label>
          </div>
          <div class="md:w-2/3">
            <input
              v-model="email"
              @keyup.enter="login"
              class="ada-text-input w-full"
              id="the-page-login--email"
              type="text"
            >
          </div>
        </div>
        <div class="md:flex md:items-center mb-6">
          <div class="md:w-1/3">
            <label
              class="ada-form-label"
              for="the-page-login--password"
            >
              {{ $t('login.password') }}
            </label>
          </div>
          <div class="md:w-2/3">
            <PasswordInput
              v-model="password"
              @keyup.enter="login"
              input-id="the-page-login--password"
            />
          </div>
        </div>
        <div class="md:flex md:items-center">
          <div class="md:w-1/3"></div>
          <div class="md:w-2/3">
            <div>
              <button class="ada-button" type="button" @click="login">
                {{ $t('login.login') }}
              </button>
            </div>
            <div class="mt-5">
              <a
                class="ada-link text-sm"
                href="/reset-password"
              >
                {{ $t('login.forgotPassword') }}
              </a>
            </div>
          </div>
        </div>
      </div>
      <div
        class="login-message my-10"
        v-if="loginProcessState === 'login is refused'"
      >
        <p>
          {{ $t('login.messages.loginRefused') }}
        </p>
        <p class="mt-4">
          {{ $t('login.messages.tryAgain') }}
        </p>
      </div>
    </div>
    <div
      v-if="loginProcessState === 'wait for request response'"
      class="login-message"
    >
      {{ $t('login.messages.requestSend') }}      
    </div>
    <div
      v-if="loginProcessState === 'user is logged in'"
      class="login-message"
    >
      {{ $t('login.messages.success') }}
    </div>
  </div>
</template>

<script>
import { ref } from 'vue'
import { useStore, useLoginProcess } from '../store.js'
import router from '../router'
import PasswordInput from './PasswordInput.vue'

export default {
  name: 'ThePageLogin',
  components: {
    PasswordInput
  },
  setup () {
    const email = ref('')
    const password = ref('')
    const { startLoginProcess, loginProcessState } = useLoginProcess()
    const { currentUserId } = useStore()
    const login = async function () {
      await startLoginProcess(email.value, password.value)
      if (loginProcessState.value === 'user is connected') {
        // If we are here that means that the process is successful, we can
        // proceed and display the current user's page.
        loginProcessState.value = 'waiting to start'
        router.push(`/people/${currentUserId.value}`)
      }
    }
    return {
      email,
      password,
      loginProcessState,
      login
    }
  }
}
</script>

<style lang="postcss" scoped>
.login-message {
  @apply ml-10;
  @apply text-center;
  @apply dark:text-gray-300;
}
</style>